#include "bits/stdc++.h"

using namespace std;

using Punkt = pair<int, int>;
using ZbiorPunktow = set<Punkt>;

struct Puzzel {
  int h, w;
  ZbiorPunktow S;

  Puzzel() {
    cin >> h >> w;
    for (int i=0; i<h; i++) {
      string linia;
      cin >> linia;
      for (int j=0; j<w; j++) {
        if (linia[j] == 'X') {
          S.emplace(i, j);
        }
      }
    }
  } 

  Puzzel WyrownajDoLewegoDolnegoRogu() {
    Punkt lewy_dolny_rog = ZnajdzLewyDolnyRog();
    Przesun(Punkt(-lewy_dolny_rog.first, -lewy_dolny_rog.second));
    Punkt rozmiar = ZnajdzRozmiar();
    h = rozmiar.first;
    w = rozmiar.second;
    return *this;
  }

  Punkt ZnajdzLewyDolnyRog() {
    vector <int> X, Y;
    for (Punkt p : S) {
      X.push_back(p.first);
      Y.push_back(p.second);
    }
    int minx = *min_element(X.begin(), X.end());
    int miny = *min_element(Y.begin(), Y.end());
    return Punkt{minx, miny};
  }

  Punkt ZnajdzPrawyGornyRog() {
    vector <int> X, Y;
    for (Punkt p : S) {
      X.push_back(p.first);
      Y.push_back(p.second);
    }
    int minx = *max_element(X.begin(), X.end());
    int miny = *max_element(Y.begin(), Y.end());
    return Punkt{minx, miny};
  }

  Puzzel Przesun(Punkt roznica) {
    ZbiorPunktow tymczasowy;
    for (Punkt p : S) {
      tymczasowy.emplace(p.first + roznica.first,
      p.second + roznica.second);
    }
    S = tymczasowy;
    return *this;
  }

  Punkt ZnajdzRozmiar() {
    Punkt lewy_dolny_rog = ZnajdzLewyDolnyRog();
    Punkt prawy_gorny_rog = ZnajdzPrawyGornyRog();
    return Punkt{prawy_gorny_rog.first - lewy_dolny_rog.first + 1,
                 prawy_gorny_rog.second - lewy_dolny_rog.second + 1};
  }

  void Obroc() {
    ZbiorPunktow nowy;
    for (Punkt p : S) nowy.emplace(w-p.second-1, p.first);
    S = nowy;
    swap(h, w);
  }

  void Odwroc() {
    ZbiorPunktow nowy;
    for (Punkt p : S) nowy.emplace(p.first, w-p.second-1);
    S = nowy;
  }

  int LiczbaPol() {
    return (int)S.size();
  }

  Punkt NajbardziejLewyZapelniony() {
    for (int j=0; j<w; j++) {
      for (int i=0; i<h; i++) {
        if (S.find({i,j}) != S.end()) return Punkt(i,j);
      }
    }
  }

  Punkt NajbardziejLewyPusty() {
    for (int j=0; j<w; j++) {
      for (int i=0; i<h; i++) {
        if (S.find({i,j}) == S.end()) return Punkt(i,j);
      }
    }
  }

  Puzzel Dodaj(Puzzel drugi_puzzel) {
    for (auto p : drugi_puzzel.S) S.insert(p);
    Punkt rozmiar = ZnajdzRozmiar();
    h = rozmiar.first;
    w = rozmiar.second;
    return *this;
  }

  bool CzyJestProstokatem() {
    return h * w == LiczbaPol();
  }
};

vector<Puzzel> WygenerujMozliwosci(Puzzel p) {
  vector<Puzzel> mozliwosci;
  for (int r=0; r<2; r++) {
    for (int i=0; i<4; i++) {
      mozliwosci.push_back(p);
      p.Obroc();
    }
    p.Odwroc();
  }
  return mozliwosci;
}

bool Pasuja(Puzzel p, Puzzel q) {
  int oczekiwana_liczba_pol = p.LiczbaPol() + q.LiczbaPol();
  Punkt lewy_pusty = p.NajbardziejLewyPusty();
  Punkt lewy_pelny = q.NajbardziejLewyZapelniony();

  Punkt przesuniecie = {lewy_pusty.first - lewy_pelny.first,
                        lewy_pusty.second - lewy_pelny.second};

  Puzzel polaczony = q.Przesun(przesuniecie).Dodaj(p);

  return polaczony.CzyJestProstokatem() and \
    polaczony.LiczbaPol() == oczekiwana_liczba_pol;
}

bool test() {
  Puzzel puzzel_a = Puzzel().WyrownajDoLewegoDolnegoRogu();
  Puzzel puzzel_b = Puzzel().WyrownajDoLewegoDolnegoRogu();
  for (auto mozliwosc_a : WygenerujMozliwosci(puzzel_a)) {
    for (auto mozliwosc_b : WygenerujMozliwosci(puzzel_b)) {
      if (Pasuja(mozliwosc_a, mozliwosc_b) or
          Pasuja(mozliwosc_b, mozliwosc_a)) {
        return true; 
      } 
    }
  }
  return false;
}

int main() {
  int T;
  cin >> T;
  while(T--) {
    if (test()) cout << "TAK\n";
    else cout << "NIE\n";
  }
}